// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: generator/integration_tests/test.proto

#ifndef GOOGLE_CLOUD_CPP_GENERATOR_INTEGRATION_TESTS_GOLDEN_MOCKS_MOCK_GOLDEN_KITCHEN_SINK_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GENERATOR_INTEGRATION_TESTS_GOLDEN_MOCKS_MOCK_GOLDEN_KITCHEN_SINK_CONNECTION_H

#include "generator/integration_tests/golden/golden_kitchen_sink_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace golden_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class MockGoldenKitchenSinkConnection : public golden::GoldenKitchenSinkConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(StatusOr<google::test::admin::database::v1::GenerateAccessTokenResponse>,
  GenerateAccessToken,
  (google::test::admin::database::v1::GenerateAccessTokenRequest const& request), (override));

  MOCK_METHOD(StatusOr<google::test::admin::database::v1::GenerateIdTokenResponse>,
  GenerateIdToken,
  (google::test::admin::database::v1::GenerateIdTokenRequest const& request), (override));

  MOCK_METHOD(StatusOr<google::test::admin::database::v1::WriteLogEntriesResponse>,
  WriteLogEntries,
  (google::test::admin::database::v1::WriteLogEntriesRequest const& request), (override));

  MOCK_METHOD(StreamRange<std::string>,
  ListLogs,
  (google::test::admin::database::v1::ListLogsRequest request), (override));

  MOCK_METHOD(StreamRange<google::test::admin::database::v1::TailLogEntriesResponse>,
  TailLogEntries,
  (google::test::admin::database::v1::TailLogEntriesRequest const& request), (override));

  MOCK_METHOD(StatusOr<google::test::admin::database::v1::ListServiceAccountKeysResponse>,
  ListServiceAccountKeys,
  (google::test::admin::database::v1::ListServiceAccountKeysRequest const& request), (override));

  MOCK_METHOD(Status,
  DoNothing,
  (google::protobuf::Empty const& request), (override));

  MOCK_METHOD((std::unique_ptr<
      ::google::cloud::AsyncStreamingReadWriteRpc<
          google::test::admin::database::v1::AppendRowsRequest, google::test::admin::database::v1::AppendRowsResponse>>),
      AsyncAppendRows, (), (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace golden_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GENERATOR_INTEGRATION_TESTS_GOLDEN_MOCKS_MOCK_GOLDEN_KITCHEN_SINK_CONNECTION_H
