// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/devtools/artifactregistry/v1/service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_ARTIFACTREGISTRY_MOCKS_MOCK_ARTIFACT_REGISTRY_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_ARTIFACTREGISTRY_MOCKS_MOCK_ARTIFACT_REGISTRY_CONNECTION_H

#include "google/cloud/artifactregistry/artifact_registry_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace artifactregistry_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class MockArtifactRegistryConnection
    : public artifactregistry::ArtifactRegistryConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(
      StreamRange<google::devtools::artifactregistry::v1::DockerImage>,
      ListDockerImages,
      (google::devtools::artifactregistry::v1::ListDockerImagesRequest request),
      (override));

  MOCK_METHOD(
      StreamRange<google::devtools::artifactregistry::v1::Repository>,
      ListRepositories,
      (google::devtools::artifactregistry::v1::ListRepositoriesRequest request),
      (override));

  MOCK_METHOD(
      StatusOr<google::devtools::artifactregistry::v1::Repository>,
      GetRepository,
      (google::devtools::artifactregistry::v1::GetRepositoryRequest const&
           request),
      (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace artifactregistry_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_ARTIFACTREGISTRY_MOCKS_MOCK_ARTIFACT_REGISTRY_CONNECTION_H
