// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/assuredworkloads/v1/assuredworkloads.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_ASSUREDWORKLOADS_MOCKS_MOCK_ASSURED_WORKLOADS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_ASSUREDWORKLOADS_MOCKS_MOCK_ASSURED_WORKLOADS_CONNECTION_H

#include "google/cloud/assuredworkloads/assured_workloads_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace assuredworkloads_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class MockAssuredWorkloadsServiceConnection
    : public assuredworkloads::AssuredWorkloadsServiceConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(future<StatusOr<google::cloud::assuredworkloads::v1::Workload>>,
              CreateWorkload,
              (google::cloud::assuredworkloads::v1::CreateWorkloadRequest const&
                   request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::assuredworkloads::v1::Workload>,
              UpdateWorkload,
              (google::cloud::assuredworkloads::v1::UpdateWorkloadRequest const&
                   request),
              (override));

  MOCK_METHOD(Status, DeleteWorkload,
              (google::cloud::assuredworkloads::v1::DeleteWorkloadRequest const&
                   request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::assuredworkloads::v1::Workload>, GetWorkload,
      (google::cloud::assuredworkloads::v1::GetWorkloadRequest const& request),
      (override));

  MOCK_METHOD(
      StreamRange<google::cloud::assuredworkloads::v1::Workload>, ListWorkloads,
      (google::cloud::assuredworkloads::v1::ListWorkloadsRequest request),
      (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace assuredworkloads_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_ASSUREDWORKLOADS_MOCKS_MOCK_ASSURED_WORKLOADS_CONNECTION_H
