// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/bigtable/admin/v2/bigtable_instance_admin.proto

#include "google/cloud/bigtable/admin/internal/bigtable_instance_admin_option_defaults.h"
#include "google/cloud/bigtable/admin/bigtable_instance_admin_connection.h"
#include "google/cloud/bigtable/admin/bigtable_instance_admin_options.h"
#include "google/cloud/common_options.h"
#include "google/cloud/connection_options.h"
#include "google/cloud/grpc_options.h"
#include "google/cloud/internal/getenv.h"
#include "google/cloud/internal/user_agent_prefix.h"
#include "google/cloud/options.h"
#include <memory>

namespace google {
namespace cloud {
namespace bigtable_admin_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options BigtableInstanceAdminDefaultOptions(Options options) {
  if (!options.has<EndpointOption>()) {
    auto env =
        internal::GetEnv("GOOGLE_CLOUD_CPP_BIGTABLE_INSTANCE_ADMIN_ENDPOINT");
    options.set<EndpointOption>(
        env && !env->empty() ? *env : "bigtableadmin.googleapis.com");
  }
  if (auto emulator =
          internal::GetEnv("BIGTABLE_INSTANCE_ADMIN_EMULATOR_HOST")) {
    options.set<EndpointOption>(*emulator).set<GrpcCredentialOption>(
        grpc::InsecureChannelCredentials());
  }
  if (!options.has<GrpcCredentialOption>()) {
    options.set<GrpcCredentialOption>(grpc::GoogleDefaultCredentials());
  }
  if (!options.has<TracingComponentsOption>()) {
    options.set<TracingComponentsOption>(internal::DefaultTracingComponents());
  }
  if (!options.has<GrpcTracingOptionsOption>()) {
    options.set<GrpcTracingOptionsOption>(internal::DefaultTracingOptions());
  }
  auto& products = options.lookup<UserAgentProductsOption>();
  products.insert(products.begin(), google::cloud::internal::UserAgentPrefix());

  if (!options.has<bigtable_admin::BigtableInstanceAdminRetryPolicyOption>()) {
    options.set<bigtable_admin::BigtableInstanceAdminRetryPolicyOption>(
        bigtable_admin::BigtableInstanceAdminLimitedTimeRetryPolicy(
            std::chrono::minutes(30))
            .clone());
  }
  if (!options
           .has<bigtable_admin::BigtableInstanceAdminBackoffPolicyOption>()) {
    options.set<bigtable_admin::BigtableInstanceAdminBackoffPolicyOption>(
        ExponentialBackoffPolicy(std::chrono::seconds(1),
                                 std::chrono::minutes(5), kBackoffScaling)
            .clone());
  }
  if (!options
           .has<bigtable_admin::BigtableInstanceAdminPollingPolicyOption>()) {
    options.set<bigtable_admin::BigtableInstanceAdminPollingPolicyOption>(
        GenericPollingPolicy<
            bigtable_admin::BigtableInstanceAdminRetryPolicyOption::Type,
            bigtable_admin::BigtableInstanceAdminBackoffPolicyOption::Type>(
            options
                .get<bigtable_admin::BigtableInstanceAdminRetryPolicyOption>()
                ->clone(),
            options
                .get<bigtable_admin::BigtableInstanceAdminBackoffPolicyOption>()
                ->clone())
            .clone());
  }
  if (!options
           .has<bigtable_admin::
                    BigtableInstanceAdminConnectionIdempotencyPolicyOption>()) {
    options.set<
        bigtable_admin::BigtableInstanceAdminConnectionIdempotencyPolicyOption>(
        bigtable_admin::
            MakeDefaultBigtableInstanceAdminConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace bigtable_admin_internal
}  // namespace cloud
}  // namespace google
