// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/binaryauthorization/v1/service.proto

#include "google/cloud/binaryauthorization/validation_helper_v1_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace binaryauthorization {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

ValidationHelperV1ConnectionIdempotencyPolicy::
    ~ValidationHelperV1ConnectionIdempotencyPolicy() = default;

namespace {
class DefaultValidationHelperV1ConnectionIdempotencyPolicy
    : public ValidationHelperV1ConnectionIdempotencyPolicy {
 public:
  ~DefaultValidationHelperV1ConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<ValidationHelperV1ConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<
        DefaultValidationHelperV1ConnectionIdempotencyPolicy>(*this);
  }

  Idempotency ValidateAttestationOccurrence(
      google::cloud::binaryauthorization::v1::
          ValidateAttestationOccurrenceRequest const&) override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<ValidationHelperV1ConnectionIdempotencyPolicy>
MakeDefaultValidationHelperV1ConnectionIdempotencyPolicy() {
  return absl::make_unique<
      DefaultValidationHelperV1ConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace binaryauthorization
}  // namespace cloud
}  // namespace google
