// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/filestore/v1/cloud_filestore_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_FILESTORE_CLOUD_FILESTORE_MANAGER_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_FILESTORE_CLOUD_FILESTORE_MANAGER_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/internal/retry_policy.h"
#include "google/cloud/version.h"
#include <google/cloud/filestore/v1/cloud_filestore_service.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace filestore {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class CloudFilestoreManagerConnectionIdempotencyPolicy {
 public:
  virtual ~CloudFilestoreManagerConnectionIdempotencyPolicy() = 0;

  /// Create a new copy of this object.
  virtual std::unique_ptr<CloudFilestoreManagerConnectionIdempotencyPolicy>
  clone() const = 0;

  virtual google::cloud::Idempotency ListInstances(
      google::cloud::filestore::v1::ListInstancesRequest request) = 0;

  virtual google::cloud::Idempotency GetInstance(
      google::cloud::filestore::v1::GetInstanceRequest const& request) = 0;

  virtual google::cloud::Idempotency CreateInstance(
      google::cloud::filestore::v1::CreateInstanceRequest const& request) = 0;

  virtual google::cloud::Idempotency UpdateInstance(
      google::cloud::filestore::v1::UpdateInstanceRequest const& request) = 0;

  virtual google::cloud::Idempotency RestoreInstance(
      google::cloud::filestore::v1::RestoreInstanceRequest const& request) = 0;

  virtual google::cloud::Idempotency DeleteInstance(
      google::cloud::filestore::v1::DeleteInstanceRequest const& request) = 0;

  virtual google::cloud::Idempotency ListBackups(
      google::cloud::filestore::v1::ListBackupsRequest request) = 0;

  virtual google::cloud::Idempotency GetBackup(
      google::cloud::filestore::v1::GetBackupRequest const& request) = 0;

  virtual google::cloud::Idempotency CreateBackup(
      google::cloud::filestore::v1::CreateBackupRequest const& request) = 0;

  virtual google::cloud::Idempotency DeleteBackup(
      google::cloud::filestore::v1::DeleteBackupRequest const& request) = 0;

  virtual google::cloud::Idempotency UpdateBackup(
      google::cloud::filestore::v1::UpdateBackupRequest const& request) = 0;
};

std::unique_ptr<CloudFilestoreManagerConnectionIdempotencyPolicy>
MakeDefaultCloudFilestoreManagerConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace filestore
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_FILESTORE_CLOUD_FILESTORE_MANAGER_CONNECTION_IDEMPOTENCY_POLICY_H
