// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/gaming/v1/game_server_deployments_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_GAMESERVICES_MOCKS_MOCK_GAME_SERVER_DEPLOYMENTS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_GAMESERVICES_MOCKS_MOCK_GAME_SERVER_DEPLOYMENTS_CONNECTION_H

#include "google/cloud/gameservices/game_server_deployments_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace gameservices_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class MockGameServerDeploymentsServiceConnection
    : public gameservices::GameServerDeploymentsServiceConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(
      StreamRange<google::cloud::gaming::v1::GameServerDeployment>,
      ListGameServerDeployments,
      (google::cloud::gaming::v1::ListGameServerDeploymentsRequest request),
      (override));

  MOCK_METHOD(StatusOr<google::cloud::gaming::v1::GameServerDeployment>,
              GetGameServerDeployment,
              (google::cloud::gaming::v1::GetGameServerDeploymentRequest const&
                   request),
              (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::gaming::v1::GameServerDeployment>>,
      CreateGameServerDeployment,
      (google::cloud::gaming::v1::CreateGameServerDeploymentRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::gaming::v1::OperationMetadata>>,
      DeleteGameServerDeployment,
      (google::cloud::gaming::v1::DeleteGameServerDeploymentRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::gaming::v1::GameServerDeployment>>,
      UpdateGameServerDeployment,
      (google::cloud::gaming::v1::UpdateGameServerDeploymentRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::gaming::v1::GameServerDeploymentRollout>,
      GetGameServerDeploymentRollout,
      (google::cloud::gaming::v1::GetGameServerDeploymentRolloutRequest const&
           request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::gaming::v1::GameServerDeployment>>,
              UpdateGameServerDeploymentRollout,
              (google::cloud::gaming::v1::
                   UpdateGameServerDeploymentRolloutRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::gaming::v1::
                           PreviewGameServerDeploymentRolloutResponse>,
              PreviewGameServerDeploymentRollout,
              (google::cloud::gaming::v1::
                   PreviewGameServerDeploymentRolloutRequest const& request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::gaming::v1::FetchDeploymentStateResponse>,
      FetchDeploymentState,
      (google::cloud::gaming::v1::FetchDeploymentStateRequest const& request),
      (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace gameservices_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_GAMESERVICES_MOCKS_MOCK_GAME_SERVER_DEPLOYMENTS_CONNECTION_H
