// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/networkmanagement/v1/reachability.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_NETWORKMANAGEMENT_MOCKS_MOCK_REACHABILITY_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_NETWORKMANAGEMENT_MOCKS_MOCK_REACHABILITY_CONNECTION_H

#include "google/cloud/networkmanagement/reachability_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace networkmanagement_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class MockReachabilityServiceConnection
    : public networkmanagement::ReachabilityServiceConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(
      StreamRange<google::cloud::networkmanagement::v1::ConnectivityTest>,
      ListConnectivityTests,
      (google::cloud::networkmanagement::v1::ListConnectivityTestsRequest
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::networkmanagement::v1::ConnectivityTest>,
      GetConnectivityTest,
      (google::cloud::networkmanagement::v1::GetConnectivityTestRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::networkmanagement::v1::ConnectivityTest>>,
      CreateConnectivityTest,
      (google::cloud::networkmanagement::v1::
           CreateConnectivityTestRequest const& request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::networkmanagement::v1::ConnectivityTest>>,
      UpdateConnectivityTest,
      (google::cloud::networkmanagement::v1::
           UpdateConnectivityTestRequest const& request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::networkmanagement::v1::ConnectivityTest>>,
      RerunConnectivityTest,
      (google::cloud::networkmanagement::v1::RerunConnectivityTestRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::networkmanagement::v1::OperationMetadata>>,
      DeleteConnectivityTest,
      (google::cloud::networkmanagement::v1::
           DeleteConnectivityTestRequest const& request),
      (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace networkmanagement_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_NETWORKMANAGEMENT_MOCKS_MOCK_REACHABILITY_CONNECTION_H
